
#include <iostream>
#include <iomanip>
#include <string>

#include "fonctions_code_decode.h"

#define taille_message 8

using namespace std;

void AffichageHexa( const unsigned char tab[], int taille, string nom)
{
int i;
        cout << nom << "[" << dec << taille << "]: ";
	for( i=0; i<taille; i++)
                cout << hex << "0x" << int(tab[i]) << " ";
        cout << endl;
}

int main(void)
{
unsigned char information[ taille_message + 1 ];
unsigned char control[ taille_message + 1 ];
unsigned char signal[ (taille_message + 1)*2 ];
unsigned char signal_bruit[ (taille_message + 1)*2 ];
unsigned char information_bruit[ taille_message + 1 ];
unsigned char control_bruit[ taille_message + 1 ];
unsigned char message_debruit[ taille_message ];

int taille_information_control = taille_message + 1;
int taille_signal = taille_information_control * 2;
int taille_message_debruit = taille_message;

unsigned char message[] = "0123456";

// Emission
CodageConvolutif( message, information, control, taille_message);
MelangeInformationControl( information, control, signal, taille_information_control);

// Bruit
BruitAdditif( signal, signal_bruit, taille_signal, 0.7, 0);

// Reception
SepareInformationControl( signal_bruit, information_bruit, control_bruit, taille_signal);
DecodageConvolutif( information_bruit, control_bruit, message_debruit, taille_information_control);

AffichageHexa( message, taille_message,	            "message        ");
cout << endl;

AffichageHexa( information, taille_information_control, "information    ");
AffichageHexa( control, taille_information_control,	    "control        ");
AffichageHexa( signal, taille_signal,		    "signal         ");
cout << endl;

AffichageHexa( signal_bruit, taille_signal,		    "signal_bruit   ");
AffichageHexa( information_bruit, taille_information_control, "information_bruit ");
AffichageHexa( control_bruit, taille_information_control, "control_bruit  ");
cout << endl;

AffichageHexa( message_debruit, taille_message_debruit, "message_debruit ");
cout << "message_debruit (char) "<< message_debruit << endl;
cout << endl;

cout << " -- pause -- " << endl;
cin.sync();
cin.get();

return 0;
}
