/*
QQ entetes de fichier:

        Formats  :
PCX : 128 octets
BMP OS/2 : 26 octets
BMP windows : 54 octets
WAV : 44 octets
*/


#include <iostream>
#include <iomanip>
#include <string>
#include <getopt.h> // analyse des arguments

#include "fonctions_code_decode.h"
#include "fonctions_fichier.h"

using namespace std;

static struct option long_options[] =
{
    {"input",  required_argument, 0, 'i'},
    {"output",  required_argument, 0, 'o'},
    {"noisy",  required_argument, 0, 'n'},
    {0, 0, 0, 0}
};

struct Parameters
{
    std::string  InputFilename;
    std::string  OutputFilename;
	std::string  NoisyFilename;
    bool isOk;
};


Parameters ArgumentAnalysis(int argc, char **argv);




double Comparaison( const unsigned char signal_ref[], const unsigned char signal[], int taille)
{
double p_erreur=0.0;
int i;
        for( i=0; i<taille; i++)
                if( signal[i] != signal_ref[i] )
                        p_erreur++;
        return (p_erreur/(1.0*taille));
}


// exemple d'utilisation
// --input "E:/Documents/Insa-GE/Modules/IF1/Langage_C+/TD/TD_Cpp_7_8/Signal/fleur2_signal_bruit.bmp.sgn" --output "E:/Documents/Insa-GE/Modules/IF1/Langage_C+/TD/TD_Cpp_7_8/Signal/fleur2_den.bmp" --noisy "E:/Documents/Insa-GE/Modules/IF1/Langage_C+/TD/TD_Cpp_7_8/Signal/fleur2_bruit.bmp"
int main(int argc, char *argv[])
{
	Parameters readParameters = ArgumentAnalysis( argc, argv);
    if( (!readParameters.isOk) || (readParameters.InputFilename == "x") || (readParameters.OutputFilename == "x") )
		{
		std::cout << " Error with parameters, exiting" << std::endl;   
		std::cout << " usage : " << std::endl;   
		std::cout << "   --input   => input file. Must be a .sgn file!" << std::endl;   
		std::cout << "   --output  => output file (bits corrected)" << std::endl;   
		std::cout << "   --noisy   => output noisy file without bit correction" << std::endl;   
        return -1;
        }
		
unsigned char *signal_bruit;
unsigned char *information_bruit;
unsigned char *control_bruit;
unsigned char *message_debruit;

int taille_information_control;
int taille_signal;
int taille_message_debruit;

// Reception
LireFichier( readParameters.InputFilename.c_str(), &signal_bruit, &taille_signal, 0);
taille_information_control = GetTailleInformationControlFromSignal( taille_signal );

//---------------------------------------------------------------------
//  completer
//
//




//----------------------------------------------------------------------

delete[] signal_bruit;

cout << " -- End. -- " << endl;
return 0;
}




//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
Parameters ArgumentAnalysis(int argc, char **argv)
{
    Parameters read;
        read.InputFilename  = std::string("x");
        read.OutputFilename = std::string("x");
        read.NoisyFilename  = std::string("x");
        read.isOk = true;
    int c;

    while (1)
    {
        /* getopt_long stores the option index here. */
        int option_index = 0;

        c = getopt_long (argc, argv, "i:o:n::",
                         long_options, &option_index);

        /* Detect the end of the options. */
        if (c == -1)
            break;

        switch (c)
        {
        case 'i':
            std::cout << "input filename: " << optarg << std::endl;
            read.InputFilename = std::string(optarg);
            break;

        case 'o':
            std::cout << "output filename : " << optarg << std::endl;
            read.OutputFilename = std::string(optarg);
            break;
		
		case 'n':
            std::cout << "noisy filename : " << optarg << std::endl;
            read.NoisyFilename = std::string(optarg);
            break;

        case '?':
            if ( ( optopt == 'i') || (optopt == 'o') || (optopt == 'n')  )
                {
                std::cerr << "Option - " << optopt << " requires an argument.\n";
                read.isOk = false;
                return read;
                }
            break;       
		
		default:
			break; //return read;
        }
    }


    return read;
}

